import java.io.IOError;
import java.sql.SQLSyntaxErrorException;
import java.util.ArrayList;
import java.util.Collections;

public class Parser {

    public AstExpression parse (ArrayList<Token> tokenList) {

        AstExpression root;

        root = (AstExpression) parseAstExpression(tokenList);

        return root;
    }

    private Ast parseAstExpression (ArrayList<Token> tokenList) {

        if(tokenList.size() == 1) {
            AstValue astValue = new AstValue();
            astValue.astNumber = new AstNumber();
            astValue.astNumber.astDigitWoz = new AstDigitWoz();

            astValue.astNumber.astDigitWoz.astDigitWozContent = Integer.parseInt(tokenList.get(0).getTokenString());
            return astValue;
        }

        AstExpression astExpression = new AstExpression();

        ArrayList<Token> tokensPos3 = new ArrayList<>();

        tokenList.forEach(token -> {
            if(token != tokenList.get(0) && token != tokenList.get(1)) {
                tokensPos3.add(token);
            }
        });


        astExpression.astBinaryOp = parseBinaryOp(tokenList.get(0), tokenList.get(1), tokensPos3);

        return astExpression;

    }

    private AstBinaryOp parseBinaryOp (Token expression1, Token operator, ArrayList<Token> expression2) {




        AstBinaryOp astBinaryOp = new AstBinaryOp();


        AstValue exp1;

        ArrayList<Token> exp1ArrayList = new ArrayList<>();
        exp1ArrayList.add(expression1);
        exp1 = (AstValue) parseAstExpression(exp1ArrayList);

        astBinaryOp.binaryOp[0] = exp1;


        astBinaryOp.binaryOp[1] = parseOperator(operator);



        // ( 2 + 3 ) + 3


        if (expression2.size() > 2) {

            astBinaryOp.binaryOp[2] = parseAstExpression(expression2);

        } else {

            AstValue exp2 = new AstValue();

            ArrayList<Token> exp2ArrayList = new ArrayList<>();
            exp2ArrayList.add(expression2.get(0));
            exp2 = (AstValue) parseAstExpression(exp2ArrayList);

            astBinaryOp.binaryOp[2] = exp2;

        }

        return astBinaryOp ;
    }

    private AstOperator parseOperator (Token operator) {

        AstOperator astOperator = new AstOperator();
        astOperator.astOperator = operator.tokenString;

        return astOperator;
    }




}
